@Program sa ulaza procita broj elemenata niza, zatim elemente niza i ispise elemente
@ u obrnutom redoslijedu koristeci rekurzivnu funkciju.
@Postoje dvije rekurzivne funkcije koje rade isto. jedna prihvata parametre kroz registre,
@ druga preko steka.


.section .text 				@ declare code area
	.extern printf
	.extern scanf
	.extern exit
	.global main			@ code entry point

	@citanje niza brojeva
	@parametri:
	@r0 - adresa niza
	@r1 - broj elemenata niza
citanje:
	stmfd	r13!, {r4,r5,lr}	@na steku se cuvaju registri koji se mijenjaju
	mov 	r4, r0			@posto se r0-r3 mijenjaju u scanf, kopiramo r0 i r1 ...
	mov	r5, r1			@... u r4 i r5
	cmp	r5, #0			@ koliko jos elemenata treba procitati?
1:
	beq	1f			@ ucitan citav niz => skok na kraj
	ldr	r0, =ulazni_format	@r0 = adresa(ulazni_format)
	mov	r1, r4			@ r1 = adresa tekuceg elementa
	add	r4, r4, #4		@ r4 = adresa sledeceg elementa, za narednu iteraciju
	bl	scanf			@ ispis tekuceg elementa
	subs	r5, r5, #1		@smanjenje brojaca uz setovanje flegova
	b	1b			@ skok unazad, petlja u kojoj se vrsi ucitavanje
1:	ldmfd	r13!, {r4,r5,pc}	@kraj funkcije
	
	
	@ispis niza unazad - prenos parametara kroz registre
	@r0 - adresa niza
	@r1 - broj elemenata niza
ispis1:
	stmfd	sp!, {lr}		@na steku cuva povratnu adresu
	cmp		r1, #1		@da li smo dosli do poslednjeg elementa?
	ble 	1f			@poslednji element => kraj rekurzije, izlazi se iz
					@poziva i usput stampaju elementi niza unazad
					@rekurzivni poziv
	stmfd	sp!, {r0,r1}		@cuvanje tekucih parametara
	add	r0, r0, #4		@r0 = adresa sledeceg elementa, za sledeci poziv
	sub	r1, r1, #1		@smanjuje se broj preostalih elemenata za ispis
	bl	ispis1
	ldmfd	sp!, {r0,r1}		@vracanje sa steka originalnih parametara
1:
	ldr	r1, [r0]		@dohvatanje tekuceg elementa
	ldr	r0, =izlazni_format
	bl	printf
	ldmfd	sp!, {pc}		@ret


	@ispis niza unazad - prenos parametara preko steka
	@[sp+4] - adresa niza
	@[sp+8] - broj elemenata niza
ispis2:
	stmfd	sp!, {lr}
	ldr	r1,[sp,#8]		@citanje parametra, broj preostalih elemenata
	cmp	r1, #1
	
	ble 	1f

	ldr	r0,[sp,#4]		@priprema parametara za rekurzivni poziv
	sub	r1, r1, #1	
	add     r0, r0, #4
	stmfd	sp!, {r0,r1}
	bl	ispis2
	add	sp, sp, #8		@oslobadjanje prostora za poziv

1:
	ldr	r1, [sp,#4]		@citanje adrese tekuceg elementa
	ldr	r1, [r1]
	ldr	r0, =izlazni_format
	bl	printf
	ldmfd	sp!, {pc}


main:
	push	{lr}
	ldr	r0, =ulazni_format	@ucitava sadrzaj lokacije adresa_ulazni_format
					@(pogledati dole sta je sadrzaj pomenute lokacije)

	ldr	r1, =n			@r1 = adresa(n)

	bl	scanf			@procita n
					
	ldr	r0, =niz		@r0 = adresa(niz)
	ldr	r1, =n			@r1 = adresa(n)
	ldr	r1, [r1]		@r1 = n
	bl	citanje

	ldr	r0, =niz		@r0 = adresa(niz)
	ldr	r1, =n			@r1 = adresa(n)
	ldr	r1, [r1]		@r1 = n
					@parametri su u registrima
	bl	ispis1

	ldr	r0, =novi_red
	bl	printf


	ldr	r0,	=niz		@r0 = adresa(niz)
	ldr	r1, =n			@r1 = adresa(n)
	ldr	r1, [r1]		@r1 = n
	stmfd sp!, {r0,r1}		@parametri se proslijedjuju na stek
	bl	ispis2
	add	sp, sp, #8

	ldr	r0, =novi_red
	bl	printf

	mov	r0, #0			@povratna vrijednost programa
	pop	{pc}			@kraj programa

.section .rodata
izlazni_format:	.asciz	"%ld "
novi_red:		.asciz	"\n"
ulazni_format:	.asciz	"%ld"

.section .data
n: 		.long	0
.align 2				
niz:	.skip 400
.end			@ end of program source

