/***************************************************************
*
*		Program "p3.c" predstavlja primere koriscenja funkcija 
*		biblioteke "stdl.a", koja obesbjedjuje funkcije za
*		standardni ulaz i standardni izlaz celih brojeva, izlaz
*		stringova, kao i API za rad sa binarnim fajlovima.
*
***************************************************************/

#include "stdl.h"													// zaglavlje koje deklarise funkcije za standardni I/O
																					// u zaglavlju su detaljno opisane funkcije

#define	BLOCK_SIZE	256


void printInfoDataAbortInterrupt(){				// Funkcija se poziva u "st.s" iz prekidne rutine za data abort.
																					// Funkcija samo treba da za potrebe debagovanja ispise informaciju da se
																					// dogodio data_abort.
																					
	char c[] = "Dogodio se data abort\0";		// Poruka za ispis.
	writes(c);															// Ispis poruke na standardni izlaz.
}


void main(){
	unsigned int i1, i2, i3; 								
	unsigned int i, count, size;						
	char s[BLOCK_SIZE];											// Bafer za podatke prilikom citanja i upisa bloka podataka.
	FILE f1, f2, f3;												// Fajl promenljive koje cuvaju redni broj.
	
	i1 = readl();														// Sa standardnog ulaza ucitava u i1 jedan neoznacen ceo 32-bitni broj.

	gets(s);																// Sa standardnog ulaza ucitava jednu liniju teksta i smjesta je u bafer s.
	writes(s);															// Na standardni izlaz ispisuje string ucitan u prethodnoj liniji.
	
	reads(s);																// Sa standardnog ulaza ucitava jedan string (rec) koriscenjem scanf("%s",...).
	writes(s);															// Na standardni izlaz ispisuje string ucitan u prethodnoj liniji.
	
	i2 = readl();														// Sa standardnog ulaza ucitava u i2 jos jedan neoznacen ceo 32-bitni broj.
	i3 = i1 + i2;														// Sabira dva ucitana broja.
	writel(i3);															// Na standardni izlaz ispisuje sadrzaj 32-bitnog celog broja (i3).
																					// Sadrzaj lokacije i3 se tumaci na nekoliko nacina (bice ispisana 3 broja):
																					// - kao decimalni neoznacen broj,
																					// - kao heksadecimalni neoznacen broj,
																					// - kao decimalni oznacen broj.
																					
																					// PRIMER RADA SA FAJLOVIMA
																					// Fajlovi se uvek posmatraju kao binarni.
																					
	f1 = fopen("fajl1");										// Otvaranje fajlova "fajl1" i "fajl2" u direktorijumu u kojem je
	f2 = fopen("fajl2");										// pokrenut "srv.elf". Fajlovi moraju postojati, inace ce biti vracena 0.
	
	f3 = fcreate("fajl3");									// Kreiranje fajla "fajl3" u istom direktorijumu u kojem je pokrenut "srv.elf"
	
	size = 0;																// Suma ukupnog broja bajtova ucitanih iz "fajl1". Jos nije pocelo citanje, 
																					// pa je pocetna vrijednost 0.
	
	while ( count = fread(f1, BLOCK_SIZE, s) ) {	// Iz fajla "fajl1" ucitava najvise BLOCK_SIZE bajtova i smjesta ih u bafer s.
																								// Funkcija vraca broj procitanih bajtova. Kada se pokusa citanje pocev od
																								// kraja fajla, funkcija vraca 0.
																							
		fwrite(f3,count,s);										// Sve bajtove procitane iz fajla "fajl1" upisuje u kreirani fajl "fajl3".
		
		writel(count);												// Na standardni izlaz ispisuje broj bajtova prepisanih u tekucoj iteraciji,
		for(i = 0; i < count; i++)						// a zatim ispisuje prepisane bajtove.
			writeb(s[i]);
			
		size += count;												// Broj bajtova procitanih u tekucoj iteraciji se dodaje 
																					// na brojac ukupno procitanih bajtova.
	}
	
	fseek(f3, size - 1);										// Postavlja novu tekucu poziciju u fajlu "fajl3" jedan bajt prije kraja fajla.
	
	while ( count = fread(f2, BLOCK_SIZE, s) ) {	// Analogno prethodnoj petlji, prepisuje sadrzaj fajla "fajl2" u
		fwrite(f3,count,s);													// fajl "fajl3", i to od tekuce pozicije. 
		writel(count);
		for(i = 0; i < count; i++) writeb(s[i]);
	}
	
	fclose(f1);															// Zatvara sve koriscene fajlove.
	fclose(f2);
	fclose(f3);
	
}


